Moved the delete-after support into generator.c.
[rsync/rsync.git] / runtests.sh
index 6212121..c4c4137 100755 (executable)
@@ -125,10 +125,11 @@ set -e
 
 RUNSHFLAGS='-e'
 
-if [ -n "$loglevel" ] && [ "$loglevel" -gt 8 ]
-then
-    if set -x
-    then
+# for Solaris
+[ -d /usr/xpg4/bin ] && PATH="/usr/xpg4/bin/:$PATH"
+
+if [ "x$loglevel" != x ] && [ "$loglevel" -gt 8 ]; then
+    if set -x; then
        # If it doesn't work the first time, don't keep trying.
        RUNSHFLAGS="$RUNSHFLAGS -x"
     fi
@@ -139,19 +140,39 @@ echo "$0 running in `pwd`"
 echo "    rsync_bin=$rsync_bin"
 echo "    srcdir=$srcdir"
 
-if test ! -f $rsync_bin
-then
+if [ -f /usr/bin/whoami ]; then
+    testuser=`/usr/bin/whoami`
+elif [ -f /usr/ucb/whoami ]; then
+    testuser=`/usr/ucb/whoami`
+elif [ -f /bin/whoami ]; then
+    testuser=`/bin/whoami`
+else
+    testuser=`id -un 2>/dev/null || echo ${LOGNAME:-${USERNAME:-${USER:-'UNKNOWN'}}}`
+fi
+
+echo "    testuser=$testuser"
+echo "    os=`uname -a`"
+
+# It must be "yes", not just nonnull
+if [ "x$preserve_scratch" = xyes ]; then
+    echo "    preserve_scratch=yes"
+else
+    echo "    preserve_scratch=no"
+fi    
+
+
+if [ ! -f "$rsync_bin" ]; then
     echo "rsync_bin $rsync_bin is not a file" >&2
     exit 2
 fi
 
-if test ! -d $srcdir
-then
+if [ ! -d "$srcdir" ]; then
     echo "srcdir $srcdir is not a directory" >&2
     exit 2
 fi
 
 RSYNC="$rsync_bin"
+#RSYNC="valgrind --tool=addrcheck $rsync_bin"
 
 export rsync_bin RSYNC
 
@@ -176,19 +197,18 @@ prep_scratch() {
     return 0
 }
 
-discard_scratch() {
-    [ -d "$scratchdir" ] && rm -rf "$scratchdir"
+maybe_discard_scratch() {
+    [ x"$preserve_scratch" != xyes ] && [ -d "$scratchdir" ] && rm -rf "$scratchdir"
     return 0
 }
 
-if [ "x$whichtests" = x ]
-then
+if [ "x$whichtests" = x ]; then
     whichtests="*.test"
 fi
 
 for testscript in $suitedir/$whichtests
 do
-    testbase=`echo $testscript | sed 's!.*/!!' | sed -e 's/.test\$//'`
+    testbase=`echo $testscript | sed -e 's!.*/!!' -e 's/.test\$//'`
     scratchdir="$scratchbase.$testbase"
 
     prep_scratch
@@ -198,25 +218,42 @@ do
     result=$?
     set -e
 
+    if [ "x$always_log" = xyes -o \( $result != 0 -a $result != 77 -a $result != 78 \) ]
+    then
+       echo "----- $testbase log follows"
+       cat "$scratchdir/test.log"
+       echo "----- $testbase log ends"
+       if [ -f "$scratchdir/rsyncd.log" ]; then
+           echo "----- $testbase rsyncd.log follows"
+           cat "$scratchdir/rsyncd.log"
+           echo "----- $testbase rsyncd.log ends"
+       fi
+    fi
+
     case $result in
     0)
        echo "PASS    $testbase"
        passed=`expr $passed + 1`
-       discard_scratch
+       maybe_discard_scratch
        ;;
     77)
-       echo "SKIP    $testbase"
+       # backticks will fill the whole file onto one line, which is a feature
+       whyskipped=`cat "$scratchdir/whyskipped"`
+       echo "SKIP    $testbase ($whyskipped)"
        skipped=`expr $skipped + 1`
-       discard_scratch
+       maybe_discard_scratch
+       ;;
+    78)
+        # It failed, but we expected that.  don't dump out error logs, 
+       # because most users won't want to see them.  But do leave
+       # the working directory around.
+       echo "XFAIL   $testbase"
+       failed=`expr $failed + 1`
        ;;
     *)
        echo "FAIL    $testbase"
-       echo "----- $testbase failed: log follows"
-       cat "$scratchdir/test.log"
-       echo "----- $testbase log ends"
        failed=`expr $failed + 1`
-       if [ "x$nopersist" = "xyes" ]
-       then
+       if [ "x$nopersist" = xyes ]; then
            exit 1
        fi
     esac